"report server controller"
import os, sys, string, types, time

# use for extreme debugging only
if 0:
	class _stdout:
		def __init__(self,ofile=None,dmpfile=None):
			self._ofile=ofile or sys.stdout
			if not dmpfile:
				dmpfile = open('/tmp/dbg.txt',os.path.isfile('/tmp/dbg.txt') and 'a' or 'w')
			self._dmpfile= dmpfile
			print >>dmpfile, '\n############################################ start'
		def write(self,msg):
			import traceback
			dmpfile = self._dmpfile
			print >>dmpfile,'[[[['
			traceback.print_stack(None,None,dmpfile)
			print >>dmpfile, msg
			print >>dmpfile,']]]]'
			self._ofile.write(msg)
	sys.stdout = _stdout()

def displayView(viewName, dictionary):
	"display a view"
	from rlextra.preppy import preppy
	print 'Content-Type: text/html';print
	if not os.path.isfile(viewName):
		print "<pre>view not found '%s'</pre>" % viewName
	else:
		dirName, filename = os.path.split(viewName)
		root, ext = os.path.splitext(filename)
		m = preppy.getModule(root, directory=dirName, savefile=0)
		m.run(dictionary)
	return ""

def getNames(filename):
	# if filename exists, return uncommented tokens in it split on whitespace.
	# (line with first nonwhite # is comment line)
	result = []
	try:
		f = open(filename)
	except:
		#raise
		pass
	else:
		lines = f.readlines()
		for l in lines:
			l = string.strip(l)
			if l[0]!="#":
				#raise "first line", l
				sl = string.split(l)
				for token in sl:
					result.append(token)
	return result

def processDocument(dictionary,document):
	if document is not None and document!="None":
		framework = __import__(document)
	else:
		from rlextra.ers import framework
	return framework.go(dictionary)

def noDocument(dictionary):
	"list available documents"
	from rlextra.preppy import preppy
	documents = dictionary["DOCUMENTS"] = getDocumentDescriptions()
	if documents is None:
		# no document descriptions, do default behavior
		dictionary["document"] = None
		return dispatch(dictionary)
	if len(documents)>1 or dictionary.has_key('action'):
		from rlextra.ers.framework import ersPath
		m = preppy.getModule("chooseDocument", directory=ersPath("html"), savefile=0)
		print "Content-Type: text/html"; print
		m.run(dictionary)
		return ""
	else:
		del dictionary['DOCUMENTS']
		dictionary['document'] = document = documents.keys()[0]
		return processDocument(dictionary,document)

def getTestFileNames():
	result = []
	fnpat = "test*.py"
	from glob import glob
	filenames = glob(fnpat)
	filenames.sort()
	return filenames

def runTests(cgi=0):
	global NCALLS
	"get a dictionary expression from each test file, run it thru dispatch"
	testfilenames = getTestFileNames()
	if not testfilenames:
		print "no test files found"
		return
	print "testfilenames:", testfilenames
	for testfilename in testfilenames:
		NCALLS = 0 # reset infinite loop detection...
		testfilecontent = open(testfilename).read()
		testfilecontent = string.strip(testfilecontent) # nuke extra whitespace
		dictionary = eval(testfilecontent, {}, {})
		if types.DictionaryType is not type(dictionary):
			raise ValueError, "bad value in test file "+repr(type(dictionary))
		print
		print "*"*30; print "*** RUNNING", testfilename, "***"; print "*"*30
		dictionary['CGI'] = cgi
		print dispatch(dictionary)
	print
	print "*"*30; print "*** TESTS COMPLETE ***"; print "*"*30
	
def getDocumentDescriptions():
	"get document descriptions or return None if no documentNames.txt"
	result = {}
	try:
		lines = open("documentNames.txt").readlines()
		# white separated names except for white lines or lines leading with #
		for line in lines:
			line = string.strip(line)
			#print repr(line), "<br>"
			if line and line[0]!="#":
				thesenames = string.split(line)
				for name in thesenames:
					try:
						module = __import__(name)
						#print repr(module)[1:-1], "<br>"
						result[name] = module.__doc__
					except:
						result[name] = '[not found]'
	except:
		result = None
	return result

NCALLS = 0
def dispatch(dictionary):
	if not dictionary.has_key('SCRIPT_PFX'):
		dictionary['SCRIPT_PFX'] = os.path.splitext(os.path.basename(sys.argv[0]))[0]
	# should run with current directory set to the server code directory
	global NCALLS
	if NCALLS==0:
		from reportlab.rl_config import T1SearchPath
		for d in '..', '.':
			d = os.path.normpath(os.path.abspath(os.path.join(d,'fonts')))
			if d not in T1SearchPath and os.path.isdir(d):
				T1SearchPath.insert(0,d)
	NCALLS = NCALLS+1
	if NCALLS>5:
		raise ValueError, "too many dispatch calls (%s) in this process: infinite loop?" % NCALLS
	LIVE = dictionary.get('LIVE',0)
	if dictionary.has_key("document"):
		return processDocument(dictionary,dictionary["document"])
	elif dictionary.has_key("view"):
		# execute a simple preppy page which is expected to
		# return HTML, or something printable to standard
		# output.  Other dict keys are passed through.
		return displayView(dictionary['view'], dictionary)
	else:
		if LIVE: raise ValueError,'No document/view specified'
		return noDocument(dictionary)

def _DEBUG(msg,mode='a'):
	print >> open('/tmp/ersdbg.txt',mode), msg

def main(cgi=1,**kw):
	SCRIPT_PFX = os.path.splitext(os.path.basename(sys.argv[0]))[0]
	D = kw.get('LOGDIR',None)
	if D:
		del kw['LOGDIR']
		sys._LOGDIR = D
	if cgi:
		if SCRIPT_PFX[:4]=='ers_' and os.path.isdir(os.path.join('..',SCRIPT_PFX[4:])):
			APPDIR = os.path.join('..',SCRIPT_PFX[4:])
		else:
			from rlextra.ers.framework import ersPath
			APPDIR = ersPath('example3')
		CONTEXT = 'HTML'
	else:
		APPDIR = os.getcwd()
		CONTEXT = 'TEXT'
	D = {
		'OUTDIR': ("../htdocs/pdfout", "../pdfout"),
		'HTTP_OUTDIR': "/pdfout/",
		'SCRIPT_PFX': os.path.splitext(os.path.basename(sys.argv[0]))[0],
		'CGI': cgi,
		'APPDIR': APPDIR,
		'CONTEXT': CONTEXT,
		'DEFAULT_DOCUMENT': None
		}
	for k in D.keys():
		if kw.has_key(k):
			D[k] = kw[k]
			del kw[k]
	if kw!={}: raise ValueError('Invalid key word arguments %s' % str(kw))

	# let them specify which one
	if D['DEFAULT_DOCUMENT'] is not None:
		D['document'] = D['DEFAULT_DOCUMENT']
	del D['DEFAULT_DOCUMENT']


	if cgi:
		import cgi
		form = cgi.FieldStorage()
		for k in form.keys():
			D[k] = form[k].value
		if D.has_key('ers_action'):
			D['action'] = D['ers_action']
			del D['ers_action']

		def run(D={}):
                	sys.stdout.write(dispatch(D))

		def _locateDir(roots,paths):
			for d in paths:
				if os.path.isabs(d):
					if os.path.isdir(d): return d
				else:
					for r in roots:
						dd = os.path.join(r,d)
						if os.path.isdir(dd): return dd
			return None


		def _log_filter(D):
			return D.get('action',None)!='getImage'

		LIVE = 0
		try:
			from rlextra.utils import log
			cwd = iwd = os.getcwd()
			OUTDIR = D['OUTDIR']
			if type(OUTDIR) is not type(()): OUTDIR = (OUTDIR,)
			del D['OUTDIR']
			#localize so it seems to be running in the app directory
			sys.stderr=sys.stdout
			D['APPDIR'] = APPDIR = os.path.abspath(D['APPDIR'])
			os.chdir(APPDIR)
			cwd = os.getcwd()
			if cwd not in sys.path: sys.path.insert(0,cwd)
			log.SCRIPT=os.path.basename(sys.argv[0])
			LIVE = max(map(os.path.isfile,('live','LIVE')))
			D['OUTDIR'] = _locateDir((iwd,cwd),OUTDIR)
			D.update({'LIVE':LIVE,'currentid':log.currentid})
			log.apply_wrapper(run,(D,),log_filter=lambda D=D,F=_log_filter: F(D))
		except:
			import traceback
			from rlextra.utils.cgisupport import quoteValue
			D['TRACEBACK_TEXT'] = TRACEBACK_TEXT = string.join(map(quoteValue,traceback.format_tb(sys.exc_traceback)),'')
			D['ERROR_TYPE'] = ERROR_TYPE = quoteValue(str(sys.exc_type))
			D['ERROR_VALUE'] = ERROR_VALUE = quoteValue(str(sys.exc_value))
			print "Content-Type: text/html"
			print
			try:
				os.chdir(cwd)
			except:
				pass
			from rlextra.ers.framework import getTemplate
			content = getTemplate(D,'errortemplate',ers=1)
			if content:
				print content
			else:
				print "<html><head><title>Enterprise Report Server Error</title></head><body>"
				print "<h1>An Error Occurred.</h1>"
				if LIVE:
					print "<p>The reference number is %s</p>" % log.currentid
				else:
					print "<pre>"
					#traceback.print_exc()
					print TRACEBACK_TEXT
					print ERROR_TYPE
					print ERROR_VALUE
					print "</pre>"
					print "(this traceback would be logged but not displayed in live mode)"
				print "</body></html>"
	else:
		"command line interpretation: accept data from stdin and all other parameters as name=value"
		argv = sys.argv[1:]
		for arg in argv:
			eq = string.find(arg, "=")
			if eq<0:
				raise ValueError, "don't understand %s (no '=' found)" % repr(arg)
			name = arg[:eq]
			value = arg[eq+1:]
			D[name] = value
		# if data is present, it's a file, read it
		if D.has_key("data"):
			fn = D["data"]
			D["data"] = open(fn).read()
		else:
			# get data from stdin
			D["data"] = sys.stdin.read()
		# strip bogus white space
		D["data"] = string.strip(D["data"])
		# if stdout is present, redirect to that stdout
		if D.has_key("stdout"):
			sys.stdout = open(D["stdout"], "w")
		if D.has_key("root"):
			os.chdir(D["root"])
		dispatch(D)

if __name__=="__main__": #noruntests
	main(0)
